#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>

RF24 radio(8, 9); // CE, CSN
const byte address[6] = "00001";
char receivedData[32] = "";
int  xAxis, yAxis;

//wheel one
int m1_EL_Start_Stop = 5; //EL
int m1_Signal_hall = 3; // Signal - Hall sensor
int m1_ZF_Direction = 4; // ZF
int m1_VR_speed = 2;  //VR
//wheel two
int m2_EL_Start_Stop = 12; //EL2
int m2_Signal_hall = 10; // Signal - Hall sensor2
int m2_ZF_Direction = 11; // ZF2
int m2_VR_speed = 9;  //VR2

//actuators
int Shoulder1= 43;
int Shoulder2= 41;
int Elbow1= 47;
int Elbow2= 49;
int enableS =45; //toggle on off
int enableE=48;     //toggle on off

//servos
int wrist= 38;
int hand= 36; 


void setup() {

  Serial.begin(9600);
  radio.begin();
  radio.openReadingPipe(0, address);
  radio.setPALevel(RF24_PA_MIN);
  radio.startListening();
}
void loop() {
  if (radio.available()) {   // If the NRF240L01 module received data
    radio.read(&receivedData, sizeof(receivedData)); // Read the data and put it into character array
    xAxis = atoi(&receivedData[0]); // Convert the data from the character array (received X value) into integer
    delay(10);
    radio.read(&receivedData, sizeof(receivedData));
    yAxis = atoi(&receivedData[0]);
    delay(10);
  }
  
  // Y-axis used for forward and backward control
  if (yAxis < 470) {
    // Set Motor 1 backward
    analogWrite(m1_VR_speed,30);
    digitalWrite(m1_ZF_Direction, LOW);
    digitalWrite(m1_EL_Start_Stop, HIGH);
    // Set Motor 2 backward
   analogWrite(m2_VR_speed,30);
   digitalWrite(m2_ZF_Direction, HIGH);
   digitalWrite(m2_EL_Start_Stop, HIGH);

  }
  else if (yAxis > 550) {
    // Set Motor 1 forward
    analogWrite(m1_VR_speed,30);
    digitalWrite(m1_EL_Start_Stop, LOW);
     digitalWrite(m1_ZF_Direction, HIGH); // forward
    // Set Motor 2 forward
    analogWrite(m2_VR_speed,30);
    digitalWrite(m2_EL_Start_Stop, LOW);
    digitalWrite(m2_ZF_Direction, LOW);

  }
  // If joystick stays in middle the motors are not moving
  else {
  analogWrite(m1_VR_speed,0); //Change second parameter to change speed
  analogWrite(m2_VR_speed,0); //Change second parameter to change speed
  digitalWrite(m1_EL_Start_Stop, LOW);
  digitalWrite(m2_EL_Start_Stop, LOW);
    
    
   
  }
  // X-axis used for left and right control
  if (xAxis < 470) {
    //right turn
    analogWrite(m1_VR_speed,30);
    digitalWrite(m1_ZF_Direction, HIGH); //backwards
    digitalWrite(m1_EL_Start_Stop, HIGH);
    analogWrite(m2_VR_speed,30);
    digitalWrite(m2_ZF_Direction, HIGH); //forward
    digitalWrite(m2_EL_Start_Stop, HIGH);
    

  }
  if (xAxis > 550) {
    //left turn
    analogWrite(m1_VR_speed,30);
    digitalWrite(m1_ZF_Direction, LOW); //forwards
    digitalWrite(m1_EL_Start_Stop, HIGH);
    analogWrite(m2_VR_speed,30);
    digitalWrite(m2_ZF_Direction, LOW); //backwards
    digitalWrite(m2_EL_Start_Stop, HIGH);
    



  
}
